#include "img_tool.h"

#include <stdio.h>

#include "typedfs.h"


void OrR(void *R1, const void *R2, unsigned maxX) // R1:=R1 or R2
{
  while(maxX>=4)
  {
    *(DWORD*)R1 |= *(DWORD*)R2;
    R1 = (DWORD*)R1 + 1;
    R2 = (DWORD*)R2 + 1;
    maxX -= 4;
  }
  while(maxX>=1)
  {
    *(BYTE*)R1 |= *(BYTE*)R2;
    R1 = (BYTE*)R1 + 1;
    R2 = (BYTE*)R2 + 1;
    maxX--;
  }
}


void AndR(void *R1, const void *R2, unsigned maxX) // R1:=R1 and R2
{
  while(maxX>=4)
  {
    *(DWORD*)R1 &= *(DWORD*)R2;
    R1 = (DWORD*)R1 + 1;
    R2 = (DWORD*)R2 + 1;
    maxX -= 4;
  }
  while(maxX>=1)
  {
    *(BYTE*)R1 &= *(BYTE*)R2;
    R1 = (BYTE*)R1 + 1;
    R2 = (BYTE*)R2 + 1;
    maxX--;
  }
}


/** In place right shift R1:=R1 shr 1 */
void ShrR(void *R, unsigned maxX)
{
BYTE PrevVal, val;
  if(R==NULL || maxX==0) return;

  PrevVal = (*(BYTE*)R & 0x80);
  while(maxX-->0)
  {
    val = *(BYTE*)R;
    *(BYTE*)R = PrevVal | (val>>1);
    R = (BYTE*)R + 1;
    PrevVal = (val & 1) ? 0x80 : 0;
  }
}


/** In place left shift R1:=R1 shl 1 */
void ShlR(void *R, unsigned maxX, unsigned char LastBit)
{
BYTE PrevVal, val;
  if(R==NULL || maxX==0) return;

  R = (BYTE*)R + maxX - 1;

  PrevVal = *(BYTE*)R & LastBit;
  while(maxX-->0)
  {
    val = *(BYTE*)R;
   *(BYTE*)R = PrevVal | (val<<1);
   R = (BYTE*)R - 1;
   PrevVal = (val & 0x80) ? 1 : 0;
  }
}


void MaxU8(unsigned char *R1, const unsigned char *R2, unsigned size)
{
  while(size-->0)
  {
    if(*R2 > *R1) *R1=*R2;
    R1++;
    R2++;
  }
}


void MinU8(unsigned char *R1, const unsigned char *R2, unsigned size)
{
  while(size-->0)
  {
    if(*R2 < *R1) *R1=*R2;
    R1++;
    R2++;
  }
}


void MaxU16(unsigned char *R1, const unsigned char *R2, unsigned size)
{
  while(size-->0)
  {
    if(*(WORD*)R2 > *(WORD*)R1) *(WORD*)R1=*(WORD*)R2;
    R1+=2;
    R2+=2;
  }
}


void MinU16(unsigned char *R1, const unsigned char *R2, unsigned size)
{
  while(size-->0)
  {
    if(*(WORD*)R2 < *(WORD*)R1) *(WORD*)R1=*(WORD*)R2;
    R1+=2;
    R2+=2;
  }
}
